%{

%}

%token <int> NUM
%token <string> ID
%token INT PLUS MINUS STAR ASSIGNEQ EQ LE GT NOT NEQ IF ELSE
    WHILE READ PRINT SEMICOLON VAR SKIP
%token LBRACE RBRACE LPAREN RPAREN EOF TRUE FALSE 
%token COMMA DOT

%left COMMA DOT
%left LT LEQ GT 
%left PLUS MINUS
%left STAR 
%right NOT 
%nonassoc RPAREN
%nonassoc ELSE
%left SEMICOLON


%start program
%type <C.program> program
%%

program:
    cmd EOF { $1 }
    ;

exp:
	| NUM { C.CONST $1 }
  | ID { C.VAR $1 } 
	| LPAREN exp RPAREN  { $2 }
	| exp PLUS exp  { C.ADD ($1,$3) }
  | exp MINUS exp { C.SUB ($1,$3) }
  | exp STAR exp  { C.MUL ($1,$3) }
	;

cond:
	| TRUE { C.TRUE }
  | FALSE { C.FALSE } 
  | ID LE NUM { C.LE ($1,$3) }
	| ID GT NUM { C.GT ($1,$3) }
	| ID EQ NUM { C.EQ ($1,$3) }
	| ID NEQ NUM { C.NEQ ($1,$3) }
	| LPAREN cond RPAREN { $2 }     
	| NOT cond { C.NOT $2 }
	;

cmd:
  | SKIP { C.SKIP }
	| IF LPAREN cond RPAREN LBRACE cmd RBRACE ELSE LBRACE cmd RBRACE { C.IF ($3,$6,$10) }
	| WHILE LPAREN cond RPAREN LBRACE cmd RBRACE {C.WHILE ($3,$6)}     
	| LPAREN cmd RPAREN  { $2 }
	| ID ASSIGNEQ exp { C.ASSIGN ($1, $3) }
	| cmd SEMICOLON cmd { C.SEQ ($1, $3) }
  | cmd SEMICOLON { $1 }
	| READ LPAREN ID RPAREN { C.READ $3 }
  | PRINT LPAREN exp RPAREN { C.PRINT $3 }
  ;

%%

let parse_error s = print_endline s
